// states constants:
var STAND = "s";
var FIGHT = "f";
var REST  = "r";
var SLEEP = "-";

var Affects = new Array;
Affects._queue  = new Queue; // queue of actions in standing pos
Affects._fight  = new Queue; // queue of actions in fighting pos
Affects._rest   = new Queue; // queue of actions in resting pos
Affects._busy   = false;
Affects._state  = STAND; 
Affects._last   = null;

profile("Affects");

// use it for change current state
function ChangeState(state)
{
  if(Affects._state != state)
  {
    Affects._state = state;
    Affects._busy = false;
    /* try to do somthing in new state */
    DoNextAffect();
  }
}

/* options: */
var ASK   = "a";
var QUIET = "q";        //!! not works...

function Affect(action,state,options)
{
  this.action  = action;
  this.options = new Options(options);
  if(IsNull(this.state))
    state = STAND;
  this.state   = state;
  this.on      = false;
}

Affect.prototype.queue = function()
{
  if(this.state == FIGHT)
    return Affects._fight;
  else if(this.state == REST)
    return Affects._rest;
  else if(this.state == STAND)
    return Affects._queue;
  else
    throw new Error(0,"Wrong state, state="+this.state);
}

function AddAffectSubst(affect,start,finish,fail)
{
  subst(start,cLGREEN+"["+affect+"] on"+cDEFAULT);
  if(!IsNull(finish))
    subst(finish,cCYAN+"["+affect+"] is gone"+cDEFAULT);
  if(!IsNull(fail))
    subst(fail,cBROWN+"["+affect+"] failed"+cDEFAULT);
}

function AddAffect(affect,action,start,finish,fail,state,options)
{
  Affects[affect] = new Affect(action,state,options);
  AddAffectSubst(affect,start,finish,fail);
  trig("["+affect+"] on",'AffectOn("'+affect+'")',":AFFECT");
  if(!IsNull(finish))
    trig("["+affect+"] is gone",'AffectOff("'+affect+'")',":AFFECT");
  if(!IsNull(fail))
    trig("["+affect+"] failed",'AffectFail("'+affect+'")',":AFFECT");
}

function SetAffectOptions(affect,opt)
{
  Affects[affect].options.Set(opt);
}

function DoNextAffect()
{
  if(!Affects._busy)
  {
    var queue;
    if(Affects._state == SLEEP)
      return;
    if(Affects._state == FIGHT)
      queue = Affects._fight;
    else if(Affects._state == REST)
      queue = Affects._rest;
    else if(Affects._state == STAND)
    {
      queue = Affects._queue;
      if(queue.IsEmpty())
        queue = Affects._fight;
      if(queue.IsEmpty())
        queue = Affects._rest;
    }
    else
      throw new Error(0,"Wrong state, Affects._state="+Affect._state);

    if(!queue.IsEmpty())
    {
      var affect = Affects._last = queue.First();
      var affobj = Affects[affect];
      if(!affobj.options.Test(ASK))
      {
        Affects._busy = true;
        Parse(affobj.action);
      }
      else
      {
        AskAffect(affect);
        AffectGet(affect);
      }
    }
  }
}

function AskAffect(affect)
{
  jmc.Send("gtell "+affect+" me please");
}

function AffectPut(affect)
{
  var queue = Affects[affect].queue();
  queue.Remove(affect);
  queue.Put(affect);
  DoNextAffect();
}

function AffectGet(affect)
{
  var aff = Affects[affect];
  aff.queue().Remove(affect);
  if(Affects._last  == affect)
  {
    Affects._last = null;
    Affects._busy = false;
    DoNextAffect();
  }
}

function AffectOn(affect)
{
  var aff = Affects[affect];
  aff.on = true;
  AffectGet(affect);
}

function AffectOff(affect)
{
  var aff = Affects[affect];
  aff.on = false;
  AffectPut(affect);
}

function AffectFail(affect)
{
  Affects[affect].on = false;
  Affects._busy = false;
  DoNextAffect();
}

function SpellFail()
{
  Affects._busy = false;
  DoNextAffect();
}
