//-- This is saving queuu, in which order data sved to profile
ProfileQueue = new Queue;

//--- Handlers

function ParseIncoming(line)
{
  if(!AntiSubstArray.Parse(line))
  {
    if(SubstArray.Parse(line))
      line = jmc.Event;
    else if(GagArray.Parse(line))
      return "";
  }
  var noansi = SkipANSI(line);
  TriggerArray.Parse(noansi);
  HighlightArray.Parse(line)
}

function ParseInput(line)
{
  try
  {
    /* check aliases */
    if(AliasArray.Parse(line))
      return null;
    /* [var] v = value {statments}* [;] */
    arr = /^(var\s)?\s*(\w+((\.\w+)|\[.+\])*)\s*=\s*(.*);?$/g.exec(line);
    if(arr!=null)
    {
      SafeEval(line);
      return null;
    }
    /* func(...) {statments}* [;] */
    arr = /^\s*(\w+(\.\w+|\[[^\]]+\])*)\s*\((.*)\)(.*)?$/g.exec(line);
    if(arr!=null)
    {
      SafeEval(line);
      return null;
    }
    /* func params[;] -> func("params") */
    var arr = /^\s*([_a-zA-Z]\w*)($|\s+(.*));?$/g.exec(line);
    if(arr!=null)
    {
      SafeEval("__type = typeof("+arr[1]+");");
      if(__type == "function")
      {
        SafeEval(arr[1]+"(\""+FixArg(arr[3])+"\")");
        return null;
      }
    }
  }
  catch(e)
  {
    ShowError(e);
  }
  return line;
}

function OnIncoming()
{
  ParseIncoming(jmc.Event);
}

function OnInput()
{
  jmc.Event = ParseInput(jmc.Event);
/*  if(jmc.Event == null) */
/*    jmc.DropEvent(); */
}

function OnLoad()
{
  ProfileVersion = null;
  _include(jmc.Profile+".dat");
  if(!isNaN(parseFloat(ProfileVersion)))
  {
    if(JDKVersion!=ProfileVersion)
    {
      //!!TODO!! Converting
    }
  }
  else if(ProfileQueue.IsEmpty())
  {
    ProfileQueue.Put("ProfileQueue");
    ProfileQueue.Put("AliasArray");
    ProfileQueue.Put("TriggerArray");
    ProfileQueue.Put("GagArray");
    ProfileQueue.Put("AntiSubstArray");
    ProfileQueue.Put("SubstArray");
    ProfileQueue.Put("HighlightArray");
    ProfileQueue.Put("TimerArray");
  }
}

function OnUnload()
{
  jmc.ShowMe("%Unloading profile: '"+jmc.Profile+".dat'");
  stream = FileSystem.CreateTextFile(jmc.Profile+".dat");
  WriteAllObjects(ProfileQueue,stream);
  stream.Close();
}

function OnTimer()
{
  var timer = TimerArray[jmc.Event];
  if(!IsUndef(timer) && !IsNull(timer.action))
    DoParse(timer.action);
}

function OnPreTimer()
{
  var timer = TimerArray[jmc.Event];
  if(!IsUndef(timer) && !IsNull(timer.preaction))
    DoParse(timer.preaction);
}

jmc.RegisterHandler("Incoming","OnIncoming()");
jmc.RegisterHandler("Input",   "OnInput()");
jmc.RegisterHandler("Load",    "OnLoad()");
jmc.RegisterHandler("Unload",  "OnUnload()");
jmc.RegisterHandler("Timer",   "OnTimer()");
jmc.RegisterHandler("PreTimer","OnPreTimer()");
