//-- very useful macroses

//-- Aliases

function alias(what,text,options)
{
  if(IsNull(text))
  {
    AliasArray.Show(what);
    return;
  }  
  var re = what;
  if(typeof(what) == "string")
    what = new RegExp("^" + FixPattern(what) + "($|\\s+)");
  AliasArray.Add(new Trigger(what,text,ALIAS+options));
}

function unalias(pattern)
{
  if(IsNull(pattern))
    return;
  var re = pattern;
  if(typeof(pattern) == "string")
    pattern = ConvertMaskToRegExp("^"+ pattern + "($|\\s+)");
  AliasArray.Remove(pattern);
}

//-- Triggers

function trig(pattern,action,options)
{
  TriggerArray.Add(new Trigger(pattern,action,options));
}

function untrig(pattern)
{
  TriggerArray.Remove(pattern);
}

function enable(group)
{
  TriggerArray.EnableGroup(group);
}

function disable(group)
{
  TriggerArray.DisableGroup(group);
}

//-- Gags

function gag(what)
{
  GagArray.Add(new Trigger(what,""));
}

function ungag(what)
{
  GagArray.Remove(what);
}

//-- Substitutions

function subst(what,text,options)
{
  SubstArray.Add(new Trigger(what,text,options));
}

function unsubst(what)
{
  SubstArray.Remove(what);
}

//-- Anti-Substitutions

function anti(what)
{
  AntiSubstArray.Add(new Trigger(what,""));
}

function unanti(what)
{
  AntiSubstArray.Remove(what);
}

// Highlights

function hlight(color,what)
{
  if(IsUndef(what))
    HighlightArray.Show(color);
  else
    HighlightArray.Add(new Trigger(what,MakeColor(color)+what+cDEFAULT));
}

function unhlight(what)
{
  HighlightArray.Remove(what);
}

//-- Profile

function profile(varname)
{
  unprofile(varname);
  ProfileQueue.Put(varname);
}

function unprofile(varname)
{
  ProfileQueue.Remove(varname);
}
