function Queue()
{
  this.head = 0;
  this.tail = -1;
}

Queue.prototype.Put = function(val)
{
  this[++this.tail] = val;
}

Queue.prototype.First = function()
{
  if(this.head > this.tail)
    throw new Error(0,"Queue underflow");
  return this[this.head];
}

Queue.prototype.Get = function()
{
  var val = this.First();
  delete this[this.head++];
  return val;
}

Queue.prototype.Remove = function(el)
{
  for(var pos = this.head; pos <= this.tail; pos++)
    if(this[pos] == el)
    {
      for(var idx = pos;idx<this.tail; idx++)
        this[idx] = this[idx+1];
      delete this[this.tail--];
    }
}

Queue.prototype.ForAll = function(func,data)
{
  for(var pos = this.head; pos <= this.tail; pos++)
    func(this[pos],data);
}

Queue.prototype.IsEmpty = function()
{
  return this.head > this.tail;
}
